# coding=utf-8
import pytest
from virgotools.pvt_utils import ascii, native_str
from PyCm import String
import sys


@pytest.mark.parametrize('s', [b'abc', u'abc', 'abc', String('abc')])
def test_ascii(s):
    s = ascii(s)
    assert s == b'abc' and isinstance(s, bytes)


@pytest.mark.parametrize('s', [b'abc', u'abc', 'abc', String('abc')])
def test_native_str(s):
    s = native_str(s)
    assert s == 'abc' and isinstance(s, str)


def test_unicode_error():
    with pytest.raises(UnicodeEncodeError):
        ascii(u'knäckebröd')

    if sys.version_info.major == 2:
        # Python2
        with pytest.raises(UnicodeEncodeError):
            native_str(u'knäckebröd')
    else:
        # Python3
        assert native_str(u'knäckebröd') == 'knäckebröd'



